Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# ACE_Naming_Context Class Reference

Maintaining accesses Name Server Databases. Allows to add NameBindings, change them, remove them and resolve NameBindings. More...

`#include <Naming_Context.h>`

Inheritance diagram for ACE_Naming_Context:

[legend]
Collaboration diagram for ACE_Naming_Context:

[legend]
List of all members.

## Public Types
enum | Context_Scope_Type { PROC_LOCAL, NODE_LOCAL, NET_LOCAL }
## Public Methods
| ACE_Naming_Context (void)
| "Do-nothing" constructor. More...
| ACE_Naming_Context (Context_Scope_Type scope_in, int light=0)
| Specifies the scope of this namespace, opens and memory-maps the associated file (if accessible) or contacts the dedicated name server process for NET_LOCAL namespace. More...
int | open (Context_Scope_Type scope_in=ACE_Naming_Context::PROC_LOCAL, int light=0)
| Specifies the scope of this namespace, opens and memory-maps the associated file (if accessible) or contacts the dedicated name server process for NET_LOCAL namespace. More...
int | close (void)
| Deletes the instance of Name Space. Must be called before switching name spaces. More...
int | close_down (void)
| Release all resources. Gets called by destructor and fini. More...
| ~ACE_Naming_Context (void)
| destructor, do some cleanup :TBD: last dtor should "compress" file. More...
virtual int | init (int argc, ACE_TCHAR *argv[])
| Initialize name options and naming context when dynamically linked. More...
virtual int | fini (void)
| Close down the test when dynamically unlinked. More...
virtual int | info (ACE_TCHAR **strp, size_t length) const
| Returns information about this context. More...
ACE_Name_Options * | name_options (void)
| Returns the ACE_Name_Options associated with the Naming_Context. More...
int | bind (const ACE_NS_WString &name_in, const ACE_NS_WString &value_in, const char *type_in="")
| Bind a new name to a naming context (Wide character strings). More...
int | bind (const char *name_in, const char *value_in, const char *type_in="")
| Bind a new name to a naming context ( character strings). More...
int | rebind (const ACE_NS_WString &name_in, const ACE_NS_WString &value_in, const char *type_in="")
| Overwrite the value or type of an existing name in a ACE_Naming_Context or bind a new name to the context, if it didn't exist yet. More...
int | rebind (const char *name_in, const char *value_in, const char *type_in="")
| Overwrite the value or type of an existing name in a ACE_Naming_Context or bind a new name to the context, if it didn't exist yet. More...
int | unbind (const ACE_NS_WString &name_in)
| Delete a name from a ACE_Naming_Context (Wide charcter strings Interface). More...
int | unbind (const char *name_in)
| Delete a name from a ACE_Naming_Context (character strings interface). More...
int | resolve (const ACE_NS_WString &name_in, ACE_NS_WString &value_out, char *&type_out)
| Get value and type of a given name binding (Wide chars). The caller is responsible for deleting both <value_out> and <type_out>! More...
int | resolve (const char *name_in, ACE_NS_WString &value_out, char *&type_out)
| Get value and type of a given name binding (Wide chars output). More...
int | resolve (const char *name_in, char *&value_out, char *&type_out)
| Get value and type of a given name binding ( chars ). The caller is responsible for deleting both <value_out> and <type_out>! More...
int | list_names (ACE_PWSTRING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of names matching a specified pattern (wchars). Matching means the names must begin with the pattern string. More...
int | list_names (ACE_PWSTRING_SET &set_out, const char *pattern_in)
| Get a set of names matching a specified pattern (chars). Matching means the names must begin with the pattern string. More...
int | list_values (ACE_PWSTRING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of values matching a specified pattern (wchars). Matching means the values must begin with the pattern string. More...
int | list_values (ACE_PWSTRING_SET &set_out, const char *pattern_in)
| Get a set of values matching a specified pattern (chars). Matching means the values must begin with the pattern string. More...
int | list_types (ACE_PWSTRING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of types matching a specified pattern (wchars). Matching means the types must begin with the pattern string. More...
int | list_types (ACE_PWSTRING_SET &set_out, const char *pattern_in)
| Get a set of types matching a specified pattern (chars). Matching means the types must begin with the pattern string. More...
virtual int | list_name_entries (ACE_BINDING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of names matching a specified pattern (wchars). More...
virtual int | list_name_entries (ACE_BINDING_SET &set_out, const char *pattern_in)
| Get a set of names matching a specified pattern (wchars). More...
virtual int | list_value_entries (ACE_BINDING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of values matching a specified pattern (wchars). More...
virtual int | list_value_entries (ACE_BINDING_SET &set_out, const char *pattern_in)
| Get a set of values matching a specified pattern (wchars). More...
virtual int | list_type_entries (ACE_BINDING_SET &set_out, const ACE_NS_WString &pattern_in)
| Get a set of types matching a specified pattern (wchars). More...
virtual int | list_type_entries (ACE_BINDING_SET &set_out, const char *pattern_in)
| Get a set of types matching a specified pattern (wchars). More...
void | dump (void)
| Dump the state of the object. More...
## Private Methods
int | local (void)
| 1 if we're on the same local machine as the name server, else 0. More...
## Private Attributes
ACE_Name_Options * | name_options_
| Keep track of the options such as database name etc per Naming Context. More...
ACE_Name_Space * | name_space_
| Name space (can be either local or remote) dynamically bound. More...
ACE_TCHAR | hostname_ [MAXHOSTNAMELEN+1]
| Holds the local hostname. More...
const ACE_TCHAR * | netnameserver_host_
| Holds name of net name server. More...
int | netnameserver_port_
| Holds port number of the net name server. More...

## Detailed Description

Maintaining accesses Name Server Databases. Allows to add NameBindings, change them, remove them and resolve NameBindings.

Manages a Naming Service . That represents a persistent string to string mapping for different scopes. The scope of a ACE_Naming_Context may be either local for the calling process (Note : A process is hereby not identified by it's pid, but by it's argv[0]. So different processes (in UNIX syntax) may access the same NameBindings), global for all processes running on one host or global for all processes on the net (that know the address of the net name server socket). Strings may be plain character strings or Wide character strings. A Name Binding consists of a name string (that's the key), a value string and an optional type string (no wide chars).

## Member Enumeration Documentation

enum ACE_Naming_Context::Context_Scope_Type

  | Enumeration values:
  PROC_LOCAL | Name lookup is local to the process.
  NODE_LOCAL | Name lookup is local to the node (host).
  NET_LOCAL | Name lookup is local to the (sub)network.

## Constructor & Destructor Documentation

ACE_Naming_Context::ACE_Naming_Context | ( | void |  | ) |

| "Do-nothing" constructor.

ACE_Naming_Context::ACE_Naming_Context | ( | Context_Scope_Type | scope_in,
|  | int | lite = 0
| ) |

| Specifies the scope of this namespace, opens and memory-maps the associated file (if accessible) or contacts the dedicated name server process for NET_LOCAL namespace. Note that <light> specifies whether or not we want to use ACE_Lite_MMap_Memory_Pool. By default we use ACE_MMap_Memory_Pool.

ACE_Naming_Context::~ACE_Naming_Context | ( | void |  | ) |

| destructor, do some cleanup :TBD: last dtor should "compress" file.

## Member Function Documentation

int ACE_Naming_Context::bind | ( | const char * | name_in,
|  | const char * | value_in,
|  | const char * | type_in = ""
| ) |

| Bind a new name to a naming context ( character strings).

int ACE_Naming_Context::bind | ( | const ACE_NS_WString & | name_in,
|  | const ACE_NS_WString & | value_in,
|  | const char * | type_in = ""
| ) |

| Bind a new name to a naming context (Wide character strings).

int ACE_Naming_Context::close | ( | void |  | ) |

| Deletes the instance of Name Space. Must be called before switching name spaces.

int ACE_Naming_Context::close_down | ( | void |  | ) |

| Release all resources. Gets called by destructor and fini.

void ACE_Naming_Context::dump | ( | void |  | ) |

| Dump the state of the object.

int ACE_Naming_Context::fini | ( | void |  | ) | `[virtual]`

| Close down the test when dynamically unlinked. Reimplemented from ACE_Shared_Object.

virtual int ACE_Naming_Context::info | ( | ACE_TCHAR ** | strp,
|  | size_t | length
| ) | const`[virtual]`

| Returns information about this context. Reimplemented from ACE_Shared_Object.

int ACE_Naming_Context::init | ( | int | argc,
|  | ACE_TCHAR * | argv[]
| ) | `[virtual]`

| Initialize name options and naming context when dynamically linked. Reimplemented from ACE_Shared_Object.

int ACE_Naming_Context::list_name_entries | ( | ACE_BINDING_SET & | set_out,
|  | const char * | pattern_in
| ) | `[virtual]`

| Get a set of names matching a specified pattern (wchars). Matching means the names must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_name_entries | ( | ACE_BINDING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) | `[virtual]`

| Get a set of names matching a specified pattern (wchars). Matching means the names must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_names | ( | ACE_PWSTRING_SET & | set_out,
|  | const char * | pattern_in
| ) |

| Get a set of names matching a specified pattern (chars). Matching means the names must begin with the pattern string.

int ACE_Naming_Context::list_names | ( | ACE_PWSTRING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) |

| Get a set of names matching a specified pattern (wchars). Matching means the names must begin with the pattern string.

int ACE_Naming_Context::list_type_entries | ( | ACE_BINDING_SET & | set_out,
|  | const char * | pattern_in
| ) | `[virtual]`

| Get a set of types matching a specified pattern (wchars). Matching means the types must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_type_entries | ( | ACE_BINDING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) | `[virtual]`

| Get a set of types matching a specified pattern (wchars). Matching means the types must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_types | ( | ACE_PWSTRING_SET & | set_out,
|  | const char * | pattern_in
| ) |

| Get a set of types matching a specified pattern (chars). Matching means the types must begin with the pattern string.

int ACE_Naming_Context::list_types | ( | ACE_PWSTRING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) |

| Get a set of types matching a specified pattern (wchars). Matching means the types must begin with the pattern string.

int ACE_Naming_Context::list_value_entries | ( | ACE_BINDING_SET & | set_out,
|  | const char * | pattern_in
| ) | `[virtual]`

| Get a set of values matching a specified pattern (wchars). Matching means the values must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_value_entries | ( | ACE_BINDING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) | `[virtual]`

| Get a set of values matching a specified pattern (wchars). Matching means the values must begin with the pattern string. Returns the complete binding associated each pattern match.

int ACE_Naming_Context::list_values | ( | ACE_PWSTRING_SET & | set_out,
|  | const char * | pattern_in
| ) |

| Get a set of values matching a specified pattern (chars). Matching means the values must begin with the pattern string.

int ACE_Naming_Context::list_values | ( | ACE_PWSTRING_SET & | set_out,
|  | const ACE_NS_WString & | pattern_in
| ) |

| Get a set of values matching a specified pattern (wchars). Matching means the values must begin with the pattern string.

int ACE_Naming_Context::local | ( | void |  | ) | `[private]`

| 1 if we're on the same local machine as the name server, else 0.

ACE_Name_Options * ACE_Naming_Context::name_options | ( | void |  | ) |

| Returns the ACE_Name_Options associated with the Naming_Context.

int ACE_Naming_Context::open | ( | Context_Scope_Type | scope_in = ACE_Naming_Context::PROC_LOCAL,
|  | int | lite = 0
| ) |

| Specifies the scope of this namespace, opens and memory-maps the associated file (if accessible) or contacts the dedicated name server process for NET_LOCAL namespace. Note that <light> specifies whether or not we want to use ACE_Lite_MMap_Memory_Pool. By default we use ACE_MMap_Memory_Pool.

int ACE_Naming_Context::rebind | ( | const char * | name_in,
|  | const char * | value_in,
|  | const char * | type_in = ""
| ) |

| Overwrite the value or type of an existing name in a ACE_Naming_Context or bind a new name to the context, if it didn't exist yet. ( charcter strings interface)

int ACE_Naming_Context::rebind | ( | const ACE_NS_WString & | name_in,
|  | const ACE_NS_WString & | value_in,
|  | const char * | type_in = ""
| ) |

| Overwrite the value or type of an existing name in a ACE_Naming_Context or bind a new name to the context, if it didn't exist yet. (Wide charcter strings interface).

int ACE_Naming_Context::resolve | ( | const char * | name_in,
|  | char *& | value_out,
|  | char *& | type_out
| ) |

| Get value and type of a given name binding ( chars ). The caller is responsible for deleting both <value_out> and <type_out>!

int ACE_Naming_Context::resolve | ( | const char * | name_in,
|  | ACE_NS_WString & | value_out,
|  | char *& | type_out
| ) |

| Get value and type of a given name binding (Wide chars output). The caller is responsible for deleting both <value_out> and <type_out>!

int ACE_Naming_Context::resolve | ( | const ACE_NS_WString & | name_in,
|  | ACE_NS_WString & | value_out,
|  | char *& | type_out
| ) |

| Get value and type of a given name binding (Wide chars). The caller is responsible for deleting both <value_out> and <type_out>!

int ACE_Naming_Context::unbind | ( | const char * | name_in | ) |

| Delete a name from a ACE_Naming_Context (character strings interface).

int ACE_Naming_Context::unbind | ( | const ACE_NS_WString & | name_in | ) |

| Delete a name from a ACE_Naming_Context (Wide charcter strings Interface).

## Member Data Documentation

ACE_TCHAR ACE_Naming_Context::hostname_[MAXHOSTNAMELEN + 1]`[private]`

| Holds the local hostname.

ACE_Name_Options* ACE_Naming_Context::name_options_`[private]`

| Keep track of the options such as database name etc per Naming Context.

ACE_Name_Space* ACE_Naming_Context::name_space_`[private]`

| Name space (can be either local or remote) dynamically bound.

const ACE_TCHAR* ACE_Naming_Context::netnameserver_host_`[private]`

| Holds name of net name server.

int ACE_Naming_Context::netnameserver_port_`[private]`

| Holds port number of the net name server.

The documentation for this class was generated from the following files:

- Naming_Context.h
- Naming_Context.cpp